/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.iptc.persistence;

import it.tidalwave.metadata.persistence.spi.UnknownPropertyException;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import it.tidalwave.image.metadata.IPTC;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class IPTCBeanAccessorTest
  {
    private IPTCBeanAccessor beanAccessor;
    private IPTC IPTC;
    
    @Before
    public void setupFixture()
      {
        beanAccessor = new IPTCBeanAccessor();
        IPTC = new IPTC();
        IPTC.setSource("Fabrizio Giudici");
//        IPTC.setContrast(Contrast.SOFT);
      }
    
    @After
    public void tearDownFixture()
      {
        beanAccessor = null;
        IPTC = null;
      }
    
    @Test
    public void testGetPropertyType() 
      throws UnknownPropertyException
      {
        assertEquals(String.class, beanAccessor.getDefaultPropertyType("#" + IPTC.SOURCE));
//        assertEquals(Integer.class, beanAccessor.getDefaultPropertyType("#" + IPTC.CONTRAST)); // enum
      }
    
    @Test
    public void testConvert()
      throws UnknownPropertyException
      {
        assertEquals("Fabrizio Giudici", beanAccessor.convertValueToPersistence("source", "Fabrizio Giudici"));
//        assertEquals(1, beanAccessor.convertValueToPersistence("contrast", Contrast.SOFT));
//        assertEquals(1, beanAccessor.convert("contrast", Contrast.SOFT));
      }
    
    @Test
    public void testConvertReverse()
      throws UnknownPropertyException
      {
        assertEquals("Fabrizio Giudici", beanAccessor.convertValueFromPersistence("source", "Fabrizio Giudici"));
//        assertEquals(Contrast.SOFT, beanAccessor.convertValueFromPersistence("contrast", 1));
//        assertEquals(Contrast.SOFT, beanAccessor.convertReverse("contrast", 1));
      }
    
    @Test
    public void testGetProperty()
      throws UnknownPropertyException
      {
        assertEquals("Fabrizio Giudici", beanAccessor.getProperty("#" + IPTC.SOURCE, IPTC));
//        assertEquals(1, beanAccessor.getProperty("#" + IPTC.CONTRAST, IPTC));
      }
    
    @Test
    public void testSetProperty()
      throws UnknownPropertyException
      {
        beanAccessor.setProperty(IPTC, "#" + IPTC.SOURCE, "John Doe");
//        beanAccessor.setProperty(IPTC, "#" + IPTC.CONTRAST, 2);
        assertEquals("John Doe", IPTC.getSource());
//        assertEquals(Contrast.HARD, IPTC.getContrast());
      }
  }